



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>WCID Devices -- Windows Compatible ID Devices</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">WCID Devices -- Windows Compatible ID Devices</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 01:32:08 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1><a href="https://github.com/pbatard/libwdi/wiki/WCID-Devices" rel="external nofollow noreferrer">WCID Devices</a></h1>
<h2>What is WCID?</h2>
<p>A&nbsp;<strong>WCID device</strong>, where WCID stands for "<strong>W</strong>indows&nbsp;<strong>C</strong>ompatible&nbsp;<strong>ID</strong>", is an USB device that provides extra information to a Windows system, in order to facilitate automated driver installation and, in some circumstances, allow immediate access.</p>
<p>WCID allows a device to be used by a Windows application almost as soon as it is plugged in, as opposed to the the usual scenario where an USB device that is neither&nbsp;<a href="http://en.wikipedia.org/wiki/Human_interface_device" rel="external nofollow noreferrer">HID</a>nor&nbsp;<a href="http://en.wikipedia.org/wiki/USB_mass_storage_device_class" rel="external nofollow noreferrer">Mass Storage</a>&nbsp;requires end-users to perform a manual driver installation. As such, WCID can bring the 'Plug-and-Play' functionality of HID and Mass Storage to&nbsp;<strong>any</strong>&nbsp;USB device (that sports a WCID aware firmware).</p>
<p>WCID is an extension of the&nbsp;<a href="http://msdn.microsoft.com/en-us/library/windows/hardware/hh450799.aspx" rel="external nofollow noreferrer">WinUSB Device</a>&nbsp;functionality, put forward by Microsoft during the Windows 8 Developer Preview and that uses capabilities (<a href="http://msdn.microsoft.com/en-us/windows/hardware/gg463179" rel="external nofollow noreferrer">Microsoft OS Descriptors</a>, or MODs) that have been part of Windows since Windows XP SP2.</p>
<p>As of May 2012, an automated WinUSB WCID driver is provided on all platforms starting with Windows Vista. On Windows 8 or later, it is native to the system which means there is no need to go online for the driver to be installed, whereas, for Vista and Windows 7, it will be obtained from the internet, through Windows Update.</p>
<h2>History</h2>
<p>Before WCID, only USB devices that belonged to a well supported class such as&nbsp;<a href="http://en.wikipedia.org/wiki/Human_interface_device" rel="external nofollow noreferrer">HID</a>(USB keyboards, mice, joysticks, etc.) or&nbsp;<a href="http://en.wikipedia.org/wiki/USB_mass_storage_device_class" rel="external nofollow noreferrer">Mass Storage</a>&nbsp;(USB disk, flash based storage, media players such as iPods, etc.) required no intervention for driver installation, since Windows took care of it automatically the first time the device was plugged in. On the other hand, other devices usually required the to manually provide and install the driver themselves. This detracted from ease of use and limited the the ability of people, who aren't familiar with the driver installation process on Windows, to use generic USB applications such as the ones based on&nbsp;<a href="http://www.libusb.info/" rel="external nofollow noreferrer">libusb</a>,&nbsp;<a href="http://libusbdotnet.sourceforge.net/V2/Index.html" rel="external nofollow noreferrer">LibUsbDotNet</a>,&nbsp;<a href="http://sourceforge.net/apps/trac/libusb-win32/wiki" rel="external nofollow noreferrer">libusb-win32</a>,&nbsp;<a href="http://code.google.com/p/usb-travis/" rel="external nofollow noreferrer">libusbK</a>&nbsp;or<a href="http://msdn.microsoft.com/en-us/library/windows/hardware/ff540046.aspx#winusb" rel="external nofollow noreferrer">WinUSB</a>.</p>
<p>However, the methods for automated driver installation of HID or Mass Storage devices (reliance of a common class, instead of a specific device ID) and the method of providing specific OS related device information (Microsoft OS Descriptors), which have been present since Windows XP SP2, can actually be combined to allow for the automated driver installation of any type of USB device.</p>
<p>In 2011, WCID&nbsp;<a href="http://msdn.microsoft.com/en-gb/library/windows/hardware/hh450799.aspx" rel="external nofollow noreferrer">was put forward by Microsoft</a>&nbsp;in the Windows 8 Developer Preview, through an updated WinUSB driver, and was confirmed to be applicable for more than just WinUSB devices.</p>
<p>In 2012, Microsoft also added the WinUSB WCID driver files to Windows Update, with the effect of bringing WCID capabilities and automated WinUSB driver installation to other recent versions of Windows.</p>
<p>As it greatly enhances user experience, WCID is now being leveraged in USB devices such as Android devices, benchmark devices, with many more expected to follow.</p>
<h2>Example</h2>
<p>The following is a screenshot of a "WINUSB" WCID device as detected by&nbsp;<a href="http://sourceforge.net/projects/libwdi/files/zadig/" rel="external nofollow noreferrer">Zadig</a>.</p>
<p>On Windows Vista or later, this device, which is neither HID nor Mass Storage, sees a driver installed automatically without any form of user intervention through either Windows Update (Windows Vista, Windows 7) or natively (Windows 8).</p>
<p>The same can also be achieved on Windows XP SP2, if a WinUSB WCID driver (i.e. a generic driver) has been installed at least once.</p>
<p><img referrerpolicy="no-referrer"src="https://github.com/pbatard/libwdi/wiki/images/WCID_Zadig.png" /></p>
<h2>WCID for end-users</h2>
<p>What WCID means for end-user is that, as long as a device is WCID, and a WCID driver with the same generic compatible ID is either available on the system or from Windows Update, no manual driver installation will be required when plugging the device. Instead, Windows will perform the driver installation automatically.</p>
<p>Moreover, an application such as&nbsp;<a href="http://sourceforge.net/projects/libwdi/files/zadig/" rel="external nofollow noreferrer">Zadig</a>&nbsp;can ensure that even on platforms where a WCID driver is not provided by Microsoft (eg. XP SP2) or when non Microsoft USB drivers are used (libusb0, libusbK), WCID can still be enabled through a one-time WCID driver installation so that, when you plug a WCID device in the future, you won't have anything to do.</p>
<p>Thus, if you are an end-user, and the device you want to use is neither HID or Mass Storage, you should ask the manufacturer whether it is WCID compatible. If not, you should ask them whether they can update the device firmware and convert it to WCID, which is very easy for them to do, as this means it will greatly enhance your user experience.</p>
<p>All in all, once manufacturers start using WCID, you should find that almost any USB device on Windows can actually become Plug-and-Play and that cumbersome USB driver installations will have become a thing of the past.</p>
<h2>WCID for manufacturers</h2>
<p>Obviously, the main advantage of WCID for device manufacturers is that it alleviates the need to provide your own drivers or your own custom driver installer application, as well as educate users with regards to driver requirements for devices that do not belong to well established USB classes. It also alleviates the need to go through WHQL, for every single device you produce, should your users want to obtain your driver through Windows Update.</p>
<p>For any user running Windows Vista or later, as long as you use&nbsp;<code>"WINUSB"</code>&nbsp;for your WCID type (in the Compatible ID Descriptor - see below), nothing more is required, and the WinUSB WCID driver, which either comes with the OS or can be fetched from Windows Update, will be installed automatically. Thus you can start developing&nbsp;<a href="http://msdn.microsoft.com/en-us/library/windows/hardware/ff540174.aspx" rel="external nofollow noreferrer">WinUSB</a>&nbsp;or&nbsp;<a href="http://libusb.info/" rel="external nofollow noreferrer">libusb</a>based applications, without having to worry about driver installation.</p>
<p>For end-users not running Windows Vista or later, or if you choose to use&nbsp;<a href="http://sourceforge.net/apps/trac/libusb-win32/wiki" rel="external nofollow noreferrer">libusb-win32</a>&nbsp;or<a href="http://code.google.com/p/usb-travis/" rel="external nofollow noreferrer">libusbK</a>&nbsp;to develop your application, you can simply either provide a one-time WCID driver installer application, such as&nbsp;<a href="http://sourceforge.net/projects/libwdi/files/zadig/" rel="external nofollow noreferrer">Zadig</a>&nbsp;or&nbsp;<a href="http://libwdi.sf.net/" rel="external nofollow noreferrer">libwdi</a>'s&nbsp;<a href="https://github.com/pbatard/libwdi/blob/master/examples/wdi-simple.c" rel="external nofollow noreferrer">wdi-simple</a>&nbsp;(both of which being Open Source and customizable to your needs), as these applications can install the WCID version of the WinUSB, libusb-win32 or libusbK drivers.</p>
<p>Also, while WCID requires the addition on additional descriptors, a lot of effort has been devoted in this page to ensure that you have all the information required to deploy WCID quickly and painlessly (i.e. near zero-cost), especially as the simple registry checks detailed below, the use of Zadig or the use of other test applications such as the&nbsp;<a href="http://libusb.info/" rel="external nofollow noreferrer">libusb</a>sample application&nbsp;<a href="https://github.com/libusb/libusb/blob/master/examples/xusb.c" rel="external nofollow noreferrer">xusb</a>&nbsp;(a Windows binary version of which is also available&nbsp;<a href="ftp://ftp.heanet.ie/pub/download.sourceforge.net/pub/sourceforge/l/li/libusb/libusb-1.0/libusb-1.0.19/libusb-1.0.19-rc1-win.7z" rel="external nofollow noreferrer">here</a>) or Linux's&nbsp;<a href="http://packages.debian.org/search?keywords=usbutils" rel="external nofollow noreferrer">usb-utils</a>&nbsp;(when updated to dump Microsoft OS Descriptors) can help validate whether your descriptors have been properly set.</p>
<p>For examples of actual WCID device implementations for AVR and PIC, as well as a typical WCID USB query trace, please have a look at the&nbsp;<a href="https://github.com/pbatard/libwdi/wiki/WCID-Devices#wiki-WCID_Device_Examples" rel="external nofollow noreferrer">Examples section</a>.</p>
<p>If positive customer experience is one of your priorities, and you want to reduce both development and support costs, you should seriously consider implementing WCID into your next device.</p>
<h2>Implementation</h2>
<p>You can find below an extended description of how WCID driver installation works on Windows, as well as the means you can use to confirm that your device is properly set for WCID.</p>
<p><strong>Important:</strong>&nbsp;Only USB 2.0 devices or later can be recognized as WCID. As per&nbsp;<a href="http://blogs.msdn.com/b/usbcoreblog/archive/2009/10/31/how-does-usb-stack-enumerate-a-device.aspx" rel="external nofollow noreferrer">the following</a>:</p>
<blockquote><p><em>If the USB Device Descriptor&rsquo;s bcdUSB field is equal to&nbsp;<code>0x0100</code>&nbsp;or&nbsp;<code>0x0110</code>, the hub driver will skip the query for the MS OS Descriptor and move to the &ldquo;Serial Number String Descriptor Query&rdquo; state</em></p></blockquote>
<p>Thus your Device Descriptor&rsquo;s bcdUSB field&nbsp;<strong>must</strong>&nbsp;be set to&nbsp;<code>0x0200</code>&nbsp;or higher.<br />Of course, this does not mean that your device has to operate at High Speed. It just means that your device complies with the USB 2.0 Specifications or higher.</p>
<h3>Microsoft OS String Descriptor</h3>
<p>The first time an USB device is plugged in, the Microsoft USB port driver (<code>usbport.sys</code>) will read the standard USB Descriptors, which includes the standard Device, Configuration, Interface and String Descriptors. It will also attempt to read an additional String Descriptor located at index&nbsp;<code>0xEE</code>. This String Descriptor, which is not mandated by the USB specifications, is a Microsoft extension called an OS String Descriptor and it is the first of two elements that establish whether a device is WCID.</p>
<p>When Windows checks for this String Descriptor, one of the first thing that happens is the creation of a registry entry, under<code>HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\usbflags</code>, that is the concatenation of&nbsp;<code>VID+PID+BCD_RELEASE_NUMBER</code>&nbsp;(This key is never deleted). In this new section, a&nbsp;<code>osvc</code>&nbsp;2 byte&nbsp;<code>REG_BINARY</code>&nbsp;key is created, that indicates whether an appropriate Microsoft OS String Descriptor was found.</p>
<ul><li>If the&nbsp;<code>0xEE</code>&nbsp;descriptor doesn't exist, or if it doesn't match the Microsoft signature (<code>"MSFT100"</code>), then&nbsp;<code>osvc</code>&nbsp;is set to&nbsp;<code>0x0000</code>, which, in our case, means that the device is not WCID.</li>
<li>If the&nbsp;<code>0xEE</code>&nbsp;descriptor exists and matches the expected organization of a Microsoft OS String Descriptor, then&nbsp;<code>oscv</code>&nbsp;is set to&nbsp;<code>0x01##</code>, where&nbsp;<code>01</code>&nbsp;indicates that the device satisfies the MS OS Vendor extensions and where&nbsp;<code>##</code>&nbsp;is the Vendor Code byte value (see below).</li></ul>
<p>The following table details how exactly the Microsoft OS String Descriptor should be set in your firmware:</p>
<table>
<caption><strong>Table 1: Microsoft OS String Descriptor</strong></caption>
<tbody>
<tr>
<th>Value</th>
<th>Type</th>
<th>Description</th>
</tr>
<tr>
<td><code>0x12</code></td>
<td>BYTE</td>
<td>Descriptor length (18 bytes)</td>
</tr>
<tr>
<td><code>0x03</code></td>
<td>BYTE</td>
<td>Descriptor type (3 = String)</td>
</tr>
<tr>
<td><code>0x4D, 0x00, 0x53, 0x00,</code><br /><code>0x46, 0x00, 0x54, 0x00,</code><br /><code>0x31, 0x00, 0x30, 0x00,</code><br /><code>0x30, 0x00</code></td>
<td>7 WORDS<br />Unicode String (LE)</td>
<td>Signature:&nbsp;<code>"MSFT100"</code></td>
</tr>
<tr>
<td><strong><code>0x##</code></strong></td>
<td>BYTE</td>
<td><strong>Vendor Code</strong></td>
</tr>
<tr>
<td><code>0x00</code></td>
<td>BYTE</td>
<td>Padding</td>
</tr>
</tbody>
</table>
<p>Below is an example of the key created by Windows 7 for a WCID device (LibusbDotNet's Benchmark device, with VID&nbsp;<code>0x04D8</code>, PID&nbsp;<code>0xFA2E</code>&nbsp;and BCD Release Number&nbsp;<code>0x0001</code>):</p>
<p><img referrerpolicy="no-referrer"src="https://github.com/pbatard/libwdi/wiki/images/WCID_osvc.png" /></p>
<p>In the example above, the Vendor Code was set to&nbsp;<code>0x20</code>&nbsp;in the firmware. Thus, you can easily find out if Windows has been able to read a valid OS Vendor signature from your device by checking the registry.</p>
<h3>Microsoft Compatible ID Feature Descriptor</h3>
<p>If the osvc is valid, then additional Microsoft-defined Feature Descriptor are issued, with each call being broken down by the OS into header retrieval, to find the size, and then full payload retrieval (thus a device should see twice as many requests as calls that are issued).</p>
<p>At least one of these calls is for the&nbsp;<code>Compatible ID Feature Descriptor</code></p>
<p>This is issued by the OS as a Vendor Request (control transfer), with&nbsp;<code>wIndex</code>&nbsp;set to<code>0x0004</code>&nbsp;and&nbsp;<code>bRequest</code>&nbsp;set to the Vendor Code previously returned, as well as the recipient part of&nbsp;<code>bmRequestType</code>&nbsp;set to Device (<code>0x00</code>, the full&nbsp;<code>bmRequestType</code>&nbsp;being set to&nbsp;<code>0xC0</code>). While these calls are issued by Windows, and you shouldn't have to duplicate them, if you want an example of&nbsp;<code>Compatible ID</code>&nbsp;as well as&nbsp;<code>Extended Properties</code>&nbsp;Feature Descriptor retrieval using&nbsp;<a href="http://libusb.info/" rel="external nofollow noreferrer">libusb</a>, see the&nbsp;<a href="https://github.com/libusb/libusb/blob/master/examples/xusb.c#L705" rel="external nofollow noreferrer"><code>read_ms_winsub_feature_descriptors()</code></a>&nbsp;function in the<a href="https://github.com/libusb/libusb/blob/master/examples/xusb.c" rel="external nofollow noreferrer"><code>xusb.c</code></a>&nbsp;sample source.</p>
<p>Thus, the second part of making your device WCID is ensuring that your firmware answers a Vendor Request with&nbsp;<code>wIndex=0x0004</code>&nbsp;and&nbsp;<code>bRequest=0x##</code>, to return a Compatible ID.</p>
<p>In its simplest form, and as documented&nbsp;<a href="http://msdn.microsoft.com/en-gb/library/windows/hardware/hh450799.aspx" rel="external nofollow noreferrer">here</a>&nbsp;the format of the data packet is as follows:</p>
<table>
<caption><strong>Table 2: Microsoft Compatible ID Feature Descriptor</strong></caption>
<tbody>
<tr>
<th>Value</th>
<th>Type</th>
<th>Description</th>
</tr>
<tr>
<td><code>0x28, 0x00, 0x00, 0x00</code></td>
<td>DWORD (LE)</td>
<td>Descriptor length (40 bytes)</td>
</tr>
<tr>
<td><code>0x00, 0x01</code></td>
<td>BCD WORD (LE)</td>
<td>Version (<code>'1.0'</code>)</td>
</tr>
<tr>
<td><code>0x04, 0x00</code></td>
<td>WORD (LE)</td>
<td>Compatibility ID<br />Descriptor index (<code>0x0004</code>)</td>
</tr>
<tr>
<td><code>0x01</code></td>
<td><strong>BYTE</strong></td>
<td>Number of sections (1)</td>
</tr>
<tr>
<td><code>0x00, 0x00, 0x00, 0x00,</code><br /><code>0x00, 0x00, 0x00</code></td>
<td>7 BYTES</td>
<td>Reserved</td>
</tr>
<tr>
<td><code>0x00</code></td>
<td>BYTE</td>
<td>Interface Number<br />(Interface #0)</td>
</tr>
<tr>
<td><code>0x01</code></td>
<td>BYTE</td>
<td>Reserved</td>
</tr>
<tr>
<td><code>0x57, 0x49, 0x4E, 0x55,</code><br /><code>0x53, 0x42, 0x00, 0x00</code></td>
<td>8 BYTES<br />(NUL-terminated?)<br />ASCII String</td>
<td>Compatible ID<br />(<code>"WINUSB\0\0"</code>)</td>
</tr>
<tr>
<td><code>0x00, 0x00, 0x00, 0x00,</code><br /><code>0x00, 0x00, 0x00, 0x00</code></td>
<td>8 BYTES<br />(NUL-terminated?)<br />ASCII String</td>
<td>Sub-Compatible ID<br />(unused)</td>
</tr>
<tr>
<td><code>0x00, 0x00, 0x00, 0x00,</code><br /><code>0x00, 0x00</code></td>
<td>6 BYTES</td>
<td>Reserved</td>
</tr>
</tbody>
</table>
<p>You can then check if the Compatible ID was properly read from your device by browsing the registry's&nbsp;<code>HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Enum\USB</code>&nbsp;tree at the location of your device. Similarly to the&nbsp;<code>osvc</code>&nbsp;key which is created on first insertion, you should find an entry with the VID and PID of your device under&nbsp;<code>USB</code>&nbsp;(eg:&nbsp;<code>VID_04D8&amp;PID_FA2E</code>).</p>
<p>Under this entry, possibly under an additional sub-entry, you should verify the content of the&nbsp;<code>CompatibleIDs</code>&nbsp;key (which is a&nbsp;<code>REG_MULTI_SZ</code>). If Windows was able to read the<code>Compatible ID</code>&nbsp;from your device, this key should include a&nbsp;<code>USB\MS_COMP_XXXXXXXX</code>&nbsp;string, where&nbsp;<code>XXXXXXXX</code>&nbsp;is what was defined in your report. For instance, if you defined&nbsp;<code>LIBUSB0</code>, you should get&nbsp;<code>USB\MS_COMP_LIBUSB0</code>&nbsp;there.</p>
<p>Here is an example of the registry entry created from the Compatible ID Feature Descriptor (<code>"WINUSB"</code>):</p>
<p><img referrerpolicy="no-referrer"src="https://github.com/pbatard/libwdi/wiki/images/WCID_CompatibleID.png" /></p>
<p>If you can find an&nbsp;<code>USB\MS_COMP_XXXXXXXX</code>&nbsp;entry for your device (here&nbsp;<code>USB\MS_COMP_WINUSB</code>), then your device qualifies as a WCID device. In other words, defining a Microsoft OS String Descriptor and a Microsoft Compatible ID Feature Descriptor in your firmware is all that's needed to turn it into a WCID device and benefit from the automated driver installation feature of Windows.</p>
<p>Other Compatible IDs than&nbsp;<code>"WINSUB"</code>&nbsp;can also be used according to the driver you want to automate the installation of. The following table provides a reference of which Compatible ID string you should use, according to the type of application you want to use your device with:</p>
<table>
<caption><strong>Table 3: Compatible ID to Application Type</strong></caption>
<tbody>
<tr>
<th>Compatible ID String</th>
<th>Application Type</th>
</tr>
<tr>
<td><code>"WINUSB\0\0"</code></td>
<td><a href="http://libusb.info/" rel="external nofollow noreferrer">libusb application</a><br /><a href="http://libusbdotnet.sourceforge.net/V2/Index.html" rel="external nofollow noreferrer">LibUsbDotNet application</a><br /><a href="http://msdn.microsoft.com/en-us/library/windows/hardware/ff540174.aspx" rel="external nofollow noreferrer">native WinUSB application</a></td>
</tr>
<tr>
<td><code>"LIBUSB0\0"</code></td>
<td><a href="http://sourceforge.net/apps/trac/libusb-win32/wiki" rel="external nofollow noreferrer">libusb-win32 application</a><br /><a href="http://libusbdotnet.sourceforge.net/V2/Index.html" rel="external nofollow noreferrer">LibUsbDotNet application</a></td>
</tr>
<tr>
<td><code>"LIBUSBK\0"</code></td>
<td><a href="http://code.google.com/p/usb-travis/" rel="external nofollow noreferrer">libusbK application</a><br /><a href="http://libusbdotnet.sourceforge.net/V2/Index.html" rel="external nofollow noreferrer">LibUsbDotNet application</a></td>
</tr>
</tbody>
</table>
<h3>Windows Automated Driver Installation</h3>
<p>The WCID automated driver installation process is best illustrated through the native automated WinUSB driver installation of Windows 8.</p>
<p>Here again, there are two requirements that must be met to allow for the automated installation of a device driver.</p>
<p>First, the inf file must include&nbsp;<code>USB\MS_COMP_XXXXXXXX</code>&nbsp;as a device identifier string. In Windows 8 (x64), if you look at the&nbsp;<code>winusb.inf</code>&nbsp;from your<code>\Windows\System32\DriverStore\FileRepository\winusb.inf_amd64_50cb26e12c0e99f2\</code>&nbsp;(or similar), you will find that this is indeed the case see:</p>
<pre class="prettyprint linenums">[Generic.Section.NTamd64]<br />
%USB\MS_COMP_WINUSB.DeviceDesc%=WINUSB,USB\MS_COMP_WINUSB

[Strings]<br />
Generic.Mfg="WinUsb Device"<br />
USB\MS_COMP_WINUSB.DeviceDesc="WinUsb Device"</pre>
<p>In comparison, the&nbsp;<code>winusb.inf</code>&nbsp;you'll find at the same location in Windows 7 is missing a<code>[Manufacturer]</code>&nbsp;section pointing to a compatible ID (but the&nbsp;<code>winusbcompat.inf</code>downloaded from Windows Update has it).</p>
<p>Secondly, the driver must have been pre-installed onto the system, which mostly means that an entry for it must exist in&nbsp;<code>\Windows\System32\DriverStore\FileRepository\</code>. On non Windows 8 platforms, this pre-installation can be done through Windows Update when trying to locate a driver.</p>
<p>As both these conditions are met by default for the WinUSB driver on Windows 8, it becomes possible to plug in a WinUSB WCID device (i.e. a WCID device that returns<code>"WINUSB"</code>&nbsp;for the Compatible ID Descriptor) and have its driver installed automatically: once Windows has populated the&nbsp;<code>CompatibleIDs</code>&nbsp;list in the registry, it will search the inf repository for a match, and if it finds one, install the relevant driver.</p>
<p>This whole process is actually nothing new, as a the same occurs for USB Class devices, such as HID or Mass Storage, where the&nbsp;<code>USB\Class_...</code>&nbsp;entry is used for the match. For instance, if you look at&nbsp;<code>input.inf</code>&nbsp;from&nbsp;<code>DriverStore\</code>&nbsp;you would see:</p>
<pre class="prettyprint linenums">[Standard.NTamd64]<br />
; Generic HID Interface (HidUsb as service)<br />
%HID.DeviceDesc% = HID_Inst,,GENERIC_HID_DEVICE,USB\Class_03&amp;SubClass_01,USB\Class_03

[Strings]<br />
HID.DeviceDesc  = "USB Input Device"<br />
StdMfg          = "(Standard system devices)"</pre>
<p>and&nbsp;<code>USB\Class_03</code>&nbsp;is what you would find as one of the&nbsp;<code>CompatibleIDs</code>&nbsp;string for an HID Joystick for instance.</p>
<h3>Defining a Device Interface GUID or other device specific properties</h3>
<p>If you read the Microsoft documentation, you will find that Microsoft OS Descriptors can be used for more than just WCID, at WCID is only a subset of it. For instance, they can be used to provide icons, URLs or other data.</p>
<p>One item that may be of interest to you, with regards to WCID devices, is the provision of additional device registry settings and especially the provision of the Device Interface GUID that you want your device to be accessed with. Just like with the Compatible ID, this too is done through a Feature Descriptor, called&nbsp;<code>Extended Properties Feature Descriptor</code>and located at&nbsp;<code>wIndex = 0x0005</code>. However, as opposed to the Compatible ID, this should be queried using an Interface Request with the full&nbsp;<code>bmRequestType</code>&nbsp;being set to&nbsp;<code>0xC1</code>.</p>
<p><strong>IMPORTANT NOTE 1:</strong>&nbsp;There is a bug/limitation in WinUSB that will force the&nbsp;<code>wIndex</code>&nbsp;of any Interface Request to the interface number. This means that, if you are using WinUSB to verify the content of your Extended Properties Feature Descriptor, you won't be able to retrieve it (unless it is only defined for interface #5).<br />If you use WinUSB on Windows to validate your descriptors, our advice then is to have your device firmware answer both Device and Interface requests when the Extended Properties Feature Descriptor is queried, so that you can use a Device Request rather than an Interface Request to validate that your descriptor is set properly. For reference, the latest&nbsp;<code>xusb</code>&nbsp;sample application from libusb has a&nbsp;<tt>-w</tt>&nbsp;switch that will force the&nbsp;<code>wIndex = 0x0005</code>&nbsp;to use the Device mode.</p>
<p><strong>IMPORTANT NOTE 2:</strong>&nbsp;The official Microsoft documentation shows the definition of a<tt>DeviceInterfaceGUID</tt>&nbsp;as a&nbsp;<tt>REG_SZ</tt>, and this is what the sample firmwares we provide at the end are defined with. However, if you are using a device with multiple interfaces, you may run into an issue where issuing a registry query to get the Device Interface GUIDs will not return the GUID of the WCID interface when it isn't the first one,&nbsp;<strong>unless</strong>&nbsp;you set your Extended Properties to return a&nbsp;<tt>DeviceInterfaceGUIDs</tt>&nbsp;property (with an&nbsp;<strong>s</strong>) as a<tt>REG_MULTI_SZ</tt>, to define your GUID. The use of&nbsp;<tt>DeviceInterfaceGUIDs</tt>&nbsp;rather than<tt>DeviceInterfaceGUID</tt>&nbsp;is what we illustrate below, so if you follow this guide, you should not run into this problem.</p>
<table>
<caption><strong>Table 4: Microsoft Extended Properties Feature Descriptor</strong></caption>
<tbody>
<tr>
<th>Value</th>
<th>TYPE</th>
<th>Description</th>
</tr>
<tr>
<td><code>0x92, 0x00, 0x00, 0x00</code></td>
<td>DWORD (LE)</td>
<td>Descriptor length<br />(246 bytes)</td>
</tr>
<tr>
<td><code>0x00, 0x01</code></td>
<td>BCD WORD (LE)</td>
<td>Version (<code>'1.0'</code>)</td>
</tr>
<tr>
<td><code>0x05, 0x00</code></td>
<td>WORD (LE)</td>
<td>Extended Property<br />Descriptor index (<code>5</code>)</td>
</tr>
<tr>
<td><code>0x01, 0x00</code></td>
<td><strong>WORD</strong>&nbsp;(LE)</td>
<td>Number of sections (<code>1</code>)</td>
</tr>
<tr>
<td><code>0x88, 0x00, 0x00, 0x00</code></td>
<td>DWORD (LE)</td>
<td>Size of the property<br />section (136 bytes)</td>
</tr>
<tr>
<td><code>0x07, 0x00, 0x00, 0x00</code></td>
<td>DWORD (LE)</td>
<td>Property data type<br />(<code>7</code>&nbsp;= Unicode<br />REG_MULTI_SZ,<br />see table below)</td>
</tr>
<tr>
<td><code>0x2a, 0x00</code></td>
<td>WORD (LE)</td>
<td>Property name<br />length (42 bytes)</td>
</tr>
<tr>
<td><code>0x44, 0x00, 0x65, 0x00,</code><br /><code>(...)</code><br /><code>0x73, 0x00, 0x00, 0x00</code></td>
<td>NUL-terminated<br />Unicode String (LE)</td>
<td>Property name<br /><code>"DeviceInterfaceGUIDs"</code></td>
</tr>
<tr>
<td><code>0x50, 0x00, 0x00, 0x00</code></td>
<td>DWORD (LE)</td>
<td>Property data<br />length (80 bytes)</td>
</tr>
<tr>
<td><code>0x7b, 0x00, 0x46, 0x00,</code><br /><code>(...)</code><br /><code>0x00, 0x00, 0x00, 0x00</code></td>
<td><strong>double NUL</strong>-terminated<br />Unicode String (LE)</td>
<td>Property name<br /><code>"{xxxxxxxx-xxxx-</code><br /><code>xxxx-xxxx-</code><br /><code>xxxxxxxxxxxx}\0\0"</code></td>
</tr>
</tbody>
</table>
<p>The property data types that you can use are defined in the following table:</p>
<table>
<caption><strong>Table 5: Data Types for the Microsoft Extended Properties Feature Descriptor</strong></caption>
<tbody>
<tr>
<th>Value</th>
<th>Type</th>
</tr>
<tr>
<td>1</td>
<td>NUL-terminated Unicode String (REG_SZ)</td>
</tr>
<tr>
<td>2</td>
<td>NUL-terminated Unicode String, that may include environment variables (REG_EXPAND_SZ)</td>
</tr>
<tr>
<td>3</td>
<td>Binary Data (REG_BINARY)</td>
</tr>
<tr>
<td>4</td>
<td>DWORD Value, little endian (REG_DWORD_LITTLE_ENDIAN)</td>
</tr>
<tr>
<td>5</td>
<td>DWORD Value, big endian (REG_DWORD_BIG_ENDIAN)</td>
</tr>
<tr>
<td>6</td>
<td>NUL-terminated Unicode String, that may include a symbolic link (REG_LINK)</td>
</tr>
<tr>
<td>7</td>
<td>Multiple NUL-terminated Unicode Strings (REG_MULTI_SZ)</td>
</tr>
</tbody>
</table>
<p>Should you define DeviceInterfaceGUIDs as highlighted above, or any other Extended Properties at index&nbsp;<code>0x0005</code>, you will find that it is copied into the registry, under the&nbsp;<code>Device Parameters</code>&nbsp;subsection of your device:</p>
<p><img referrerpolicy="no-referrer"src="https://github.com/pbatard/libwdi/wiki/images/WCID_DeviceParameters.png" /></p>
<p>As you can see, the&nbsp;<code>{F70242C7-FB25-443B-9E7E-A4260F373982}</code>&nbsp;that was defined in the Extended Properties Descriptors has properly been populated in the registry. You can therefore use the Extended Properties Descriptors to define any additional registry entry that your device may require, and then use the usual Microsoft APIs, such as&nbsp;<a href="http://msdn.microsoft.com/en-us/library/windows/hardware/ff549791.aspx" rel="external nofollow noreferrer">SetupDi</a>&nbsp;to read this data in your application.</p>
<h3>Example of a complete OS Feature Descriptor query</h3>
<p>For further details of the data that a WCID device, that also has the (optional)<code>DeviceInterfaceGUID</code>&nbsp;defined, should return, what follows is an example of what&nbsp;<code>xusb</code>against WCID-enabled Benchmark device. All the screenshots and data sections described above have been produced with this device. You can obtain a standalone&nbsp;<code>xusb</code>executable for Windows by downloading the latest Windows binary archive from<a href="http://libusb.info/" rel="external nofollow noreferrer">http://libusb.info</a>.</p>
<pre class="prettyprint linenums">Opening device...<br />
bus: 7, port path from HCD: 4-&gt;3<br />
speed: 12 Mbit/s (USB 1.0 FullSpeed)

Reading device descriptor:<br />
            length: 18<br />
      device class: 0<br />
               S/N: 3<br />
           VID:PID: 04D8:FA2E<br />
         bcdDevice: 0001<br />
   iMan:iProd:iSer: 1:2:3<br />
          nb confs: 1

Reading configuration descriptors:<br />
             nb interfaces: 1<br />
              interface[0]: id = 0<br />
interface[0].altsetting[0]: num endpoints = 2<br />
   Class.SubClass.Protocol: 00.00.00<br />
       endpoint[0].address: 01<br />
           max packet size: 0020<br />
          polling interval: 00<br />
       endpoint[1].address: 81<br />
           max packet size: 0020<br />
          polling interval: 00

Claiming interface 0...

Reading string descriptors:<br />
   String (0x01): "Travis Robinson"<br />
   String (0x02): "Benchmark Device"<br />
   String (0x03): "LUSBW1"<br />
   String (0xEE): "MSFT100 "

Reading Extended Compat ID OS Feature Descriptor (wIndex = 0x0004):

  00000000  28 00 00 00 00 01 04 00 01 00 00 00 00 00 00 00  (...............<br />
  00000010  00 01 57 49 4e 55 53 42 00 00 00 00 00 00 00 00  ..WINUSB........<br />
  00000020  00 00 00 00 00 00 00 00                          ........

Reading Extended Properties OS Feature Descriptor (wIndex = 0x0005):

  00000000  92 00 00 00 00 01 05 00 01 00 88 00 00 00 07 00  ................<br />
  00000010  00 00 2a 00 44 00 65 00 76 00 69 00 63 00 65 00  ..*.D.e.v.i.c.e.<br />
  00000020  49 00 6e 00 74 00 65 00 72 00 66 00 61 00 63 00  I.n.t.e.r.f.a.c.<br />
  00000030  65 00 47 00 55 00 49 00 44 00 73 00 00 00 50 00  e.G.U.I.D.s...P.<br />
  00000040  00 00 7b 00 46 00 37 00 30 00 32 00 34 00 32 00  ..{.F.7.0.2.4.2.<br />
  00000050  43 00 37 00 2d 00 46 00 42 00 32 00 35 00 2d 00  C.7.-.F.B.2.5.-.<br />
  00000060  34 00 34 00 33 00 42 00 2d 00 39 00 45 00 37 00  4.4.3.B.-.9.E.7.<br />
  00000070  45 00 2d 00 41 00 34 00 32 00 36 00 30 00 46 00  E.-.A.4.2.6.0.F.<br />
  00000080  33 00 37 00 33 00 39 00 38 00 32 00 7d 00 00 00  3.7.3.9.8.2.}...<br />
  00000090  00 00                                            ..

Releasing interface 0...<br />
Closing device...</pre>
<h2>WCID Advantages</h2>
<ul><li>Actual Plug-and-Play for end-users</li>
<li><strong>Zero</strong>&nbsp;(Windows 8 native, Windows 7 through Windows Update) or&nbsp;<strong>one</strong>&nbsp;manual driver installation required, ever</li>
<li>No need to go through WHQL and have a driver in Windows Update</li>
<li>Reduced time to market and applications that can support future devices</li>
<li>Much faster driver installation times (on Windows 8 or later, or once the WCID driver has been pre installed on Windows 7 or earlier)</li>
<li>Works on&nbsp;<strong>all</strong>&nbsp;currently supported versions of Windows, starting with Windows XP SP2</li></ul>
<h2>WCID Drawbacks</h2>
<ul><li>On Windows 7 or earlier, there is no known way to populate the device name during the driver installation, which means that WCID devices will be listed under the same generic name (<code>WinUsb Device</code>) in Device Manager. On Windows 8 or later, and if a Product String Descriptor has been defined, the device will be listed under this name.</li>
<li>Only WinUSB on Windows Vista or later requires no user intervention whatsoever. For libusb-win32 or libusbK, or for WinUSB on Windows XP, the WCID driver must have been manually installed at least once (but only once)</li></ul>
<h2>WCID Device Examples:</h2>
<h3>PIC</h3>
<p>For reference, an implementation of a typical&nbsp;<a href="http://code.google.com/p/usb-travis/source/browse/#svn%2Ftrunk%2FBmFW%2FMCP%2FUSB_Device_Benchmark%2FFirmware" rel="external nofollow noreferrer">Microchip PIC USB device firmware</a>&nbsp;(with this&nbsp;<a href="http://code.google.com/p/usb-travis/source/detail?r=141" rel="external nofollow noreferrer">diff</a>&nbsp;providing an accurate indication of how much work is actually needed).</p>
<h3>AVR (LUFA)</h3>
<p>Also for reference, a simple&nbsp;<a href="http://www.fourwalledcubicle.com/LUFA.php" rel="external nofollow noreferrer">LUFA</a>&nbsp;based WCID firmware for Atmel AVR chips, that can be compiled using&nbsp;<a href="http://www.atmel.com/microsite/avr_studio_5/default.asp?source=redirect" rel="external nofollow noreferrer">AVR Studio 5</a>, is also provided&nbsp;<a href="http://sourceforge.net/projects/libwdi/files/misc/" rel="external nofollow noreferrer">here</a>.</p>
<h3>STM32</h3>
<p>Another sample, for STM32 based (32-bit ARM Cortex) WCID devices, has been provided by&nbsp;<strong>Darren Kattan</strong>&nbsp;of&nbsp;<a href="http://immense.net/" rel="external nofollow noreferrer">Immense Networks</a>. The sample is based on the USB Device Library V3.3.0, freely available on the ST website. Here is what Darren had to say about the samples:</p>
<blockquote><p>I literally made zero changes to core USB code. The stack is designed in such a way that there are callbacks to your user code for USB requests that the core code doesn&rsquo;t recognize. Nothing but 4 files had to be changed to make it work:</p>
<ul><li><code>USB_prop.c/.h</code></li>
<li><code>USB_desc.c/.h</code></li></ul>
<p>I had to change the PLL settings to work with my hardware, so people working with dev boards will have to change them back. My target has a 16MHz clock instead of a 25MHz like most Connectivity Line dev boards have.</p></blockquote>
<p>The v3.3.0 library archive can be found&nbsp;<a href="https://sourceforge.net/projects/libwdi/files/misc/" rel="external nofollow noreferrer">here</a>&nbsp;and is labelled&nbsp;<code>STM32F1XX V3.3.0 (WinUSB).rar</code>. Also in the same directory are v2.1.0 library files labelled&nbsp;<code>STM32_USB-Host-Device_Lib_V2.1.0 (WINUSB HID).rar</code>.</p>
<p>Note that the only project that was modified in each library was the HID project.</p>
<h3>Other</h3>
<p>Finally, a&nbsp;<a href="http://www.microsoft.com/download/en/details.aspx?id=4865" rel="external nofollow noreferrer">Microsoft NetMon</a>&nbsp;trace (using the USB extensions &mdash; for more details, please see&nbsp;<a href="http://pete.akeo.ie/2011/03/troubleshooting-usb-device-development.html" rel="external nofollow noreferrer">this blog post</a>) is also available&nbsp;<a href="http://sourceforge.net/projects/libwdi/files/misc/" rel="external nofollow noreferrer">here</a>, that illustrates the USB queries your device will receive, and how it should answer them, the first time it is plugged on a Windows machine.</p>
<h2>Aditional Links</h2>
<ul><li><a href="http://msdn.microsoft.com/en-us/library/windows/hardware/hh450799.aspx" rel="external nofollow noreferrer">WinUSB Device (MSDN)</a></li>
<li><a href="http://www.sourcequest.com/modsContent.htm" rel="external nofollow noreferrer">Overview of Microsoft OS Descriptors by SourceQuest</a></li>
<li><a href="http://msdn.microsoft.com/en-us/library/windows/hardware/ff537430.aspx" rel="external nofollow noreferrer">Microsoft-Defined USB Descriptors (MSDN)</a></li>
<li><a href="http://msdn.microsoft.com/en-us/windows/hardware/gg487321" rel="external nofollow noreferrer">Microsoft USB FAQ (MSDN)</a>&nbsp;&rarr; "What is a Microsoft OS Descriptor?"</li>
<li><a href="http://msdn.microsoft.com/en-us/windows/hardware/gg463179" rel="external nofollow noreferrer">Microsoft OS Descriptors Overview (MSDN)</a></li>
<li><a href="http://blogs.msdn.com/b/usbcoreblog/archive/2009/10/31/how-does-usb-stack-enumerate-a-device.aspx" rel="external nofollow noreferrer">How does USB stack enumerate a device? (MSDN)</a></li></ul>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qxk14e8.html">function变量困惑</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mjkp08.html">XmlSerializer的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2ympw8.html">谈谈Java程序员进阶的那些知识和方向</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q70n5e8.html">Elasticsearch 数据搜索篇&amp;&num;183&semi;【入门级干货】</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnklzkq.html">Vijos P1769 网络的关键边</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k726j9.html">如何配置 URLScan 工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2owdo9.html">详解Java的MyBatis框架中SQL语句映射部分的编写</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdv6z38.html">如何让 Drupal 使用 Wordpress 形式的编辑代码？</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjgevz9.html">Umbraco中的Member登录时的Lock out功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj2lyz9.html">简单dp-poj-2231-Moo Volume</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnxlrpq.html">通过代码创建label  计算最佳尺寸  让其自适应文本高度或宽度</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mjnvxq.html">gcc的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm26z09.html">【数据结构】之二叉树的java实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj1zn28.html">Oracle Client&colon; TNS&colon; Connect timeout ocurred&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1g7zxq.html">扩展Python模块系列&lpar;一&rpar;----开发环境配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m4gpj8.html">swift 开发学习问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz737e8.html">UNIX网络编程&mdash;&mdash;非阻塞accept</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpev059.html">&lbrack;Inside HotSpot&rsqb; C1编译器HIR的构造</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlll2w6q.html">sql server 性能调优之 逻辑内存消耗最大资源分析1 &lpar;自sqlserver服务启动以后&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1gjr1q.html">maven仓库设置</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8ko1kx5q.html">服务器环境配置安装（mysql&plus;redis&plus;nodejs&plus;nginx）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mjnr0o8.html">atom使用markdown</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jm0dw09.html">2017&sol;05&sol;17  java 基础  随笔</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvev71j9.html">5 THINGS TOP BUG BOUNTY HUNTERS DO DIFFERENTLY</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jm0g1e9.html">mac ssh 自动登陆设置</a>
			</li>
						<li><a href="https://www.batexi.com/a/963on249.html">iOS仿安卓手势解锁</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jm046g9.html">appium入门级教程（1）&mdash;&mdash; appium介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/902vx64q.html">&lpar;转载）How browsers work--Behind the scenes of modern web browsers （前端必读）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4py0zjq.html">Flume分布式日志收集系统</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gpmwx79.html">Map知识点Utilities后续整理（关于Collections，Array，增强for循环）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
